package com.ninegag.android.blitz2

import com.jakewharton.rxrelay2.BehaviorRelay
import io.reactivex.Observable

abstract class RxDataSource<Model, PagingKey, QueryParam: DataSource.QueryParam>
    : DataSource<Model, PagingKey> {

    val listStateRelay = BehaviorRelay.create<Int>()
    val errorStateRelay = BehaviorRelay.create<Throwable>()

    var nextKey: String? = null
    var prevKey: String? = null

    abstract fun createInitLoadObservable(
            queryParam: QueryParam
    ): Observable<BlitzQueryResult<Model, PagingKey>>

    abstract fun createLoadNextObservable(
            queryParam: QueryParam
    ): Observable<BlitzQueryResult<Model, PagingKey>>

    abstract fun createLoadPrevObservable(
            queryParam: QueryParam
    ): Observable<BlitzQueryResult<Model, PagingKey>>

    abstract fun createQueryParam(pageInfo: PagingInfo<Model, PagingKey>?): QueryParam

    /**
     * To create an QueryParam that will invalidate list data completely
     */
    abstract fun createInvalidationQueryParam(): QueryParam
}