package com.ninegag.android.blitz2.adapter

import androidx.annotation.LayoutRes
import androidx.recyclerview.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup

/**
 * Created by raymond on 7/9/2016.
 */

open class BlitzSingleViewAdapter<V : View>(@param:LayoutRes private val layoutId: Int) : BlitzSubAdapter<BlitzSubAdapter.ViewHolder>() {
    private var listener: View.OnClickListener? = null
    lateinit var view: V
        private set

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): BlitzSubAdapter.ViewHolder {

        return if (layoutId != NO_VIEW_HOLDER) {
            val v = LayoutInflater.from(parent.context).inflate(layoutId, parent, false)
            view = v as V
            ViewHolder(v)
        } else {
            val v = View(parent.context)
            ViewHolder(v)
        }
    }

    override fun onBindViewHolder(holder: BlitzSubAdapter.ViewHolder, position: Int) {
        if (listener != null) {
            holder.itemView.setOnClickListener(listener)
        }
    }

    override fun getItemCount(): Int {
        if (!::view.isInitialized) {
            return 1
        }

        return if (View.VISIBLE == view.visibility) 1 else 0
    }

    fun setOnClickListener(listener: View.OnClickListener) {
        this.listener = listener
    }

    private class ViewHolder(itemView: View) : BlitzSubAdapter.ViewHolder(itemView)

    companion object {
        var NO_VIEW_HOLDER = 0
    }
}
