package com.ninegag.android.blitz2.adapter

import androidx.annotation.CallSuper
import androidx.recyclerview.widget.RecyclerView
import android.view.View

import java.lang.ref.WeakReference

/**
 * Code copied from https://github.com/martijnvdwoude/recycler-view-merge-adapter
 * @param <VH>
</VH> */
abstract class BlitzSubAdapter<VH : BlitzSubAdapter.ViewHolder> : RecyclerView.Adapter<VH>() {

    @CallSuper
    override fun onBindViewHolder(vh: VH, i: Int) {
        vh.adapter = this
    }

    open class ViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        private var mAdapter: WeakReference<out RecyclerView.Adapter<*>>? = null

        var adapter: RecyclerView.Adapter<*>?
            get() = if (mAdapter != null) mAdapter!!.get() else null
            set(adapter) {
                this.mAdapter = WeakReference<RecyclerView.Adapter<*>>(adapter)
            }

        /**
         * Don't call, seems broken. itemView.getParent() isn't return anything
         * @return
         */
        val subAdapterPosition: Int
            @Deprecated("")
            get() {
                var adapterPosition = super.getAdapterPosition()

                val parentRecyclerView = itemView.parent as RecyclerView

                if (parentRecyclerView.adapter is BlitzMergeAdapter<*> && (parentRecyclerView.adapter as BlitzMergeAdapter<*>).mAdapters.size > 1) {

                    for (localAdapter in (parentRecyclerView.adapter as BlitzMergeAdapter<*>).mAdapters) {
                        val adapter = (localAdapter as BlitzMergeAdapter.LocalAdapter).mAdapter

                        if (this.mAdapter != null && adapter === this.mAdapter!!.get()) {
                            break
                        } else {
                            adapterPosition -= adapter.itemCount
                        }
                    }
                }

                return adapterPosition
            }
    }
}
