package com.under9.android.comments.api

import com.under9.android.comments.model.api.ApiCommentList
import com.under9.android.comments.model.api.ApiUserStatus

import io.reactivex.Flowable
import retrofit2.adapter.rxjava2.Result
import retrofit2.http.Field
import retrofit2.http.FormUrlEncoded
import retrofit2.http.POST

interface CommentApiService {

    @FormUrlEncoded
    @POST("user.json")
    fun getUserStatus(@Field("appId") appId: String): Flowable<Result<ApiUserStatus>>


    @FormUrlEncoded
    @POST("comment-list.json")
    fun getCommentList(@Field("appId") appId: String,
                       @Field("url") url: String,
                       @Field("order") order: String?,
                       @Field("count") count: Int?,
                       @Field("ref") ref: String?,
                       @Field("refCommentId") refCommentId: String?,
                       @Field("direction") direction: String?,
                       @Field("commentId") commentId: String?): Flowable<Result<ApiCommentList>>
}
