package com.under9.android.comments.api

import com.under9.android.comments.model.api.ApiCommentList
import com.under9.android.comments.model.api.ApiInfo

import io.reactivex.Flowable
import io.reactivex.Observable
import retrofit2.adapter.rxjava2.Result
import retrofit2.http.GET
import retrofit2.http.Query

interface CommentCdnApiService {

    @GET("cacheable/comment-list.json")
    fun getCommentList(@Query("appId") appId: String,
                       @Query("url") url: String,
                       @Query("order") order: String?,
                       @Query("count") count: Int?,
                       @Query("ref") ref: String?,
                       @Query("refCommentId") refCommentId: String?,
                       @Query("direction") direction: String?,
                       @Query("commentId") commentId: String?): Flowable<Result<ApiCommentList>>

    @GET("cacheable/app.json")
    fun getAppInfo(@Query("id") appId: String): Flowable<Result<ApiInfo>>
}
