package com.under9.android.comments.data.repository

import com.under9.android.comments.data.query.info.AppInfoResult
import io.reactivex.Flowable

interface AppInfoRepositoryInterface {
    fun mayFetchInfo(force: Boolean): Flowable<AppInfoResult>

    fun allowAnonymousVote(): Boolean
    fun allowAnonymousComment(): Boolean
    fun mobileUsernameClickable(): Boolean
    fun isEnableOpLabelFeature(): Boolean
    fun isEnableOpHideCommentFeature(): Boolean
    fun allowImageUploadFeature(): Boolean

    fun getAnonymousAvatarUrl(): String
    fun getMaxCommentLevel(): Int
    fun getLastInfoUpdateTime(): Long
}