package com.under9.android.comments.model.wrapper

import androidx.collection.ArrayMap
import com.google.gson.reflect.TypeToken
import com.under9.android.comments.model.Comment

object CommentWrapperHelper {
    val mapTypeToken = object: TypeToken<ArrayMap<String, String>>() {}.type

    /**
     *
     */
    @JvmStatic fun isAnonymous(comment: Comment?): Boolean {
        return comment != null && comment.isAnonymous != null && comment.isAnonymous
    }

    /**
     *
     */
    @JvmStatic fun isCommentCreator(comment: Comment?, userId: String?): Boolean {
        if (comment == null) {
            return false
        }
        val user = comment.user ?: return false

        return user.userId == userId || user.userId == "anon_$userId"
    }

    @JvmStatic fun isOP(comment: Comment?): Boolean {
        return comment?.commentLabel == com.under9.android.comments.helper.CommentHelper.LABEL_OP
    }
}