package com.under9.android.comments.model.wrapper

import android.content.Context
import android.text.Spanned
import com.under9.android.comments.data.repository.AppInfoRepositoryInterface
import com.under9.android.comments.model.Comment
import com.under9.android.comments.ui.renderer.ExpandableCommentItemBinder
import com.under9.android.lib.util.TimeAgo
import com.under9.android.lib.util.TimeFormatter

/**
 * This is a transitional interface for the old [CommentItemRendererV4] and [ExpandableCommentItemBinder]
 */
interface CommentWrapperInterface {
    fun getId(): Long
    fun getCommentId(): String

    fun getLikeStatus(): Int
    fun getLikeCount(): Int
    fun getDislikeStatus(): Int
    fun getDislikeCount(): Int
    fun shouldHighlight(): Boolean
    fun isPending(): Boolean

    fun getComment(): Comment?
    fun getPoints(): Int
    fun getMentionedAccountId(username: String): String?
    fun getEmbedMediaMeta(): EmbedMediaMeta?
    fun getFirstMediaEmbedImage(): EmbedImage?
    fun getTime(): Long
    fun getTimeText(timeFormatter: TimeFormatter): String

    fun isAnonymous(): Boolean
    fun getDisplayName(): String
    fun getUrl(): String?
    fun getParentComment(): Comment?
    /**
     * There are two [getLevel] interface, this is to make it more flexible as one
     * will depends on the maximum level defined in server
     */
    fun getLevel(): Int
    fun getLevel(appInfoRepository: AppInfoRepositoryInterface): Int
    fun getUserName(context: Context): String
    fun getIsProUser(): Boolean

    fun getUserEmojiStatus(): String
    fun getUserCountryEmoji(): String
    fun getAvatarUrl(): String?
    fun getCommentLabel(): String?

    fun getType(): Int
    fun isMediaTextAvailable(): Boolean
    @Deprecated("Server will not recognize url anymore, it should be identified by client")
    fun isUrl(): Boolean

    fun getContent(): String?
    fun getHtmlMediaText(): Spanned?
    fun getHtmlRichtext(): Spanned?
    fun getHtmlContent(): Spanned?
    fun isRichtextAvailable(): Boolean

    /**
     * @see com.under9.android.comments.model.constant.CommentConstant.STATUS_NORMAL
     * @see com.under9.android.comments.model.constant.CommentConstant.STATUS_PROCESSING
     */
    fun getStatus(): Int

    fun getIsProPlusUser(): Boolean

    fun isUserActive(): Boolean
}