package com.under9.android.comments.ui

import android.view.View
import android.widget.ListView
import com.under9.android.lib.util.IListItemFinder
import com.under9.android.lib.util.ListItemFindingStrategy
import io.reactivex.annotations.NonNull
import java.lang.ref.WeakReference

// TODO This implmentation is duplicate from RecyclerViewItemListFinder, should use that class after migrate to recyclerview view
class AutoPlayCommentListViewListItemFinder<L : List<ITEM>, ITEM>(listView: ListView, private val mItemList: List<ITEM>): IListItemFinder<ITEM> {

    private val mRef: WeakReference<ListView> = WeakReference(listView)

    override fun findListItem(@NonNull finderHelper: ListItemFindingStrategy<ITEM>) {
        val listView = mRef.get() ?: return

        val first = listView.firstVisiblePosition
        val count = listView.childCount

        var foundPos = NOT_FOUND_POS

        val upperLine = finderHelper.upperLine
        val lowerLine = finderHelper.lowerLine
        val triggerLine = lowerLine / 2
        val listSize = mItemList.size

        var view: View? = null

        for (i in 0 until count) {
            val pos = first + i - finderHelper.prependAdapterOffset

            if (!finderHelper.shouldCheckView(listView.getChildAt(pos), pos)) {
                continue
            }
            view = listView.getChildAt(i)
            if (view == null) continue

            val top = view.top
            val bottom = view.bottom
            if (upperLine in top..bottom) {
                foundPos = pos
                if (foundPos in (NOT_FOUND_POS + 1)..(listSize - 1)) {
                    finderHelper.onItemFound(view, first, foundPos, mItemList[foundPos])
                }
            }
            if (top > triggerLine || bottom < upperLine) {
                finderHelper.onViewPassed(view, first, pos)
            }
        }

        if (mItemList.isEmpty()) {
            finderHelper.onItemPositionOutOfBound(view, first, NOT_FOUND_POS)
        } else {
            if (foundPos >= listSize) {
                finderHelper.onItemPositionOutOfBound(view, first, foundPos)
            }
        }
    }

    companion object {
        private val TAG = "ListViewListItemFinder"
        private val DEBUG = false

        private val NOT_FOUND_POS = -1
    }
}
