package com.under9.android.comments.ui.fragment

import com.under9.android.comments.model.wrapper.CommentWrapperInterface
import com.under9.android.comments.ui.fragment.dialog.MoreActionDropdownDialogFragment
import java.lang.ref.WeakReference

class DefaultMoreActionCallback(
        view: CommentListingViewInterface,
        private val onItemClickListener: com.under9.android.comments.ui.renderer.RendererItemActionListener
) : MoreActionDropdownDialogFragment.MoreActionCallback {


    private val TAG = "DefaultMoreActionCallback"
    private val viewRef = WeakReference<CommentListingViewInterface>(view)

    override fun onItemDelete(commentWrapper: CommentWrapperInterface?) {
        onItemClickListener.onItemDelete(0, commentWrapper)
    }

    override fun onItemReport(commentWrapper: CommentWrapperInterface?) {
        onItemClickListener.onItemReport(0, commentWrapper)
    }

    override fun onItemHide(commentWrapper: CommentWrapperInterface?) {
        onItemClickListener.onItemHide(0, commentWrapper)
    }

    override fun onItemCopy(commentWrapper: CommentWrapperInterface?) {
        onItemClickListener.onItemCopy(commentWrapper)
    }

    override fun onItemReply(commentWrapper: CommentWrapperInterface, prefill: String?) {
        onItemClickListener.onItemReply(0, commentWrapper, prefill ?: "", null)
    }

    override fun onItemShare(commentWrapper: CommentWrapperInterface?) {
        onItemClickListener.onItemShare(commentWrapper)
    }

    override fun onItemGoProfile(commentWrapper: CommentWrapperInterface?) {
        viewRef.get()?.getActivity()?.let { activity ->
            commentWrapper?.let {
                onItemClickListener.onAuthorNameClick(commentWrapper.getUserName(activity))
            }
        }
    }

    override fun onItemLike(commentWrapper: CommentWrapperInterface?) {
        commentWrapper?.let {
            onItemClickListener.onItemLike(0, commentWrapper.getCommentId())
        }
    }

    override fun onItemDislike(commentWrapper: CommentWrapperInterface?) {
        commentWrapper?.let {
            onItemClickListener.onItemDislike(0, commentWrapper.getCommentId())
        }
    }

    override fun onItemUnlike(commentWrapper: CommentWrapperInterface?) {
        commentWrapper?.let {
            onItemClickListener.onItemUnlike(0, commentWrapper.getCommentId())
        }
    }

    override fun onItemProBadge(commentWrapper: CommentWrapperInterface?) {
        commentWrapper?.let {
            onItemClickListener.onItemProBadge(commentWrapper)
        }
    }
}
