package com.under9.android.comments.ui.fragment.dialog

import android.content.Context
import com.under9.android.commentsystem.R
import com.under9.android.lib.bottomsheet.data.BottomSheetMenuItems

object CommentBottomSheetBuilder {

    @JvmStatic
    fun buildActionTextSheet(isOp: Boolean, isCommentCreator: Boolean, context: Context): BottomSheetMenuItems {
        val titles = arrayListOf<String>()
        val icons = arrayListOf<Int>()
        val ids = arrayListOf<Int>()

        with(context) {
            var ta = context.resources.obtainTypedArray(R.array.cs_actionSheetTitles)
            for (i in 0 until ta.length()) {
                titles.add(getString(ta.getResourceId(i, -1)))
            }
            ta.recycle()

            ta = context.resources.obtainTypedArray(R.array.cs_actionSheetIcons)
            for (i in 0 until ta.length()) {
                icons.add(ta.getResourceId(i, -1))
            }
            ta.recycle()

            ta = context.resources.obtainTypedArray(R.array.cs_actionSheetIds)
            for (i in 0 until ta.length()) {
                ids.add(ta.getResourceId(i, -1))
            }
            ta.recycle()

            if (isOp || isCommentCreator) {
                titles.remove(getString(R.string.report_comment))
                icons.remove(R.drawable.ic_error)
                ids.remove(R.id.action_report_comment)
            } else {
                titles.remove(getString(R.string.delete_comment))
                icons.remove(R.drawable.ic_delete)
                ids.remove(R.id.action_delete_comment)
            }
        }
        return BottomSheetMenuItems(titles, icons, ids)
    }

    @JvmStatic
    fun buildActionMediaSheet(context: Context): BottomSheetMenuItems {
        val titles = arrayListOf<String>()
        val icons = arrayListOf<Int>()
        val ids = arrayListOf<Int>()

        with(context) {
            var ta = context.resources.obtainTypedArray(R.array.cs_actionSheetMediaTitles)
            for (i in 0 until ta.length()) {
                titles.add(getString(ta.getResourceId(i, -1)))
            }
            ta.recycle()

            ta = context.resources.obtainTypedArray(R.array.cs_actionSheetMediaIcons)
            for (i in 0 until ta.length()) {
                icons.add(ta.getResourceId(i, -1))
            }
            ta.recycle()

            ta = context.resources.obtainTypedArray(R.array.cs_actionSheetMediaIds)
            for (i in 0 until ta.length()) {
                ids.add(ta.getResourceId(i, -1))
            }
            ta.recycle()
        }
        return BottomSheetMenuItems(titles, icons, ids)
    }

}