package com.under9.android.comments.ui.fragment.singlecomment

import android.content.res.ColorStateList
import android.os.Build
import androidx.core.widget.CompoundButtonCompat
import androidx.appcompat.content.res.AppCompatResources
import androidx.appcompat.widget.AppCompatCheckBox
import android.view.View
import android.widget.ImageButton
import android.widget.LinearLayout
import android.widget.ProgressBar
import android.widget.TextView
import com.facebook.drawee.view.SimpleDraweeView
import com.under9.android.commentsystem.R
import com.under9.android.lib.util.UiUtil
import com.xwray.groupie.ViewHolder

class CommentViewHolder(view: View) : ViewHolder(view) {
    var commentPosition: Int = 0
    var dataView: View? = null
    var indentation:View? = null
    var avatar: SimpleDraweeView? = null
    var userName: TextView? = null
    var commentLabel:TextView? = null
    var pointsCountView:TextView? = null
    var meta:TextView? = null
    var content:TextView? = null
    var customMeta: TextView? = null

    var replyBtnV4: TextView? = null
    var likeBtn: AppCompatCheckBox? = null
    var dislikeBtn:AppCompatCheckBox? = null
    var moreBtn: ImageButton? = null

    var commentBorder: View? = null

    var loadMoreContainer: View? = null
    var loadMoreTxt:View? = null
    var throbber: ProgressBar? = null

    var rightContainer: LinearLayout? = null

    var likeCountView: TextView? = null
    var dislikeCountView:TextView? = null

    init {
        with(view) {
            dataView = findViewById(R.id.dataView)
            indentation = findViewById(R.id.indentation)
            avatar = findViewById(R.id.avatar)
            userName = findViewById(R.id.userName)
            commentLabel = findViewById(R.id.commentLabel)
            pointsCountView = findViewById(R.id.likeCount)
            customMeta = findViewById(R.id.customMeta)
            meta = findViewById(R.id.meta)
            content = findViewById(R.id.content)

            likeBtn = findViewById(R.id.likeBtn)
            likeBtn?.buttonDrawable = AppCompatResources.getDrawable(context, R.drawable.ic_comment_upvote_v2)

            dislikeBtn = findViewById(R.id.dislikeBtn)
            dislikeBtn?.buttonDrawable = AppCompatResources.getDrawable(context, R.drawable.ic_comment_downvote_v2)

            if (Build.VERSION.SDK_INT < Build.VERSION_CODES.M) {
                val states = arrayOf(intArrayOf(android.R.attr.state_checked), intArrayOf(-android.R.attr.state_checked))
                val colors = intArrayOf(UiUtil.themeAttributeToColor(R.attr.under9_themeColorAccent, context, -1), UiUtil.themeAttributeToColor(R.attr.under9_themeIconColor, context, -1))
                val stateList = ColorStateList(states, colors)
                CompoundButtonCompat.setButtonTintList(likeBtn as AppCompatCheckBox, stateList)
                CompoundButtonCompat.setButtonTintList(dislikeBtn as AppCompatCheckBox, stateList)
            }

            moreBtn = findViewById(R.id.moreBtn)
            replyBtnV4 = findViewById(R.id.replyBtnV4)
            loadMoreContainer = findViewById(R.id.loadMoreContainer)
            loadMoreTxt = findViewById(R.id.loadMoreTxt)
            throbber = loadMoreContainer?.findViewById(R.id.throbber)
            commentBorder = findViewById(R.id.commentBorder)
            rightContainer = findViewById(R.id.rightContainer)
            likeCountView = findViewById(R.id.tvLikeCount)
            dislikeCountView = findViewById(R.id.tvDislikeCount)

            // TODO: 3/1/2019 Renderer config?
//            holder.likeBtn.setVisibility(if (getRendererConfig().mEnableUpvote) View.VISIBLE else View.GONE)
//            holder.dislikeBtn.setVisibility(if (getRendererConfig().mEnableDownvote) View.VISIBLE else View.GONE)
//            holder.moreBtn.setVisibility(if (getRendererConfig().mShowMoreActions) View.VISIBLE else View.GONE)
//            holder.replyBtnV4.setVisibility(if (getRendererConfig().mShowInlineReply) View.VISIBLE else View.GONE)
        }
    }
}