package com.under9.android.comments.ui.renderer

import android.view.View
import android.view.ViewGroup
import com.under9.android.comments.model.wrapper.CommentWrapper
import com.under9.android.commentsystem.R
import com.under9.android.lib.network.DomainMapperModule
import kotlinx.android.synthetic.main.comment_system_list_item_inner_v5.view.*

open class CommentItemMediaRendererV5 (
        private val isSeparateSubLevelLoadMore: Boolean,
        private val isReverse: Boolean,
        private val commentItemRenderer: CommentItemRendererV5,
        private val dmm: DomainMapperModule
) : BaseCommentAdapterRenderer() {

    private val commentMediaItemRendererDelegate = CommentMediaItemRendererDelegate(
            appInfoRepository, dataController, dmm, commentItemActionDelegate)

    override fun getView(pos: Int, convertView: View?, container: ViewGroup?,
                         item: Any?, renderOptions: RenderOptions?): View {
        val view = commentItemRenderer.getView(pos, convertView, container, item, renderOptions)
        val wrapper = item as CommentWrapper
        val holder = view.getTag(R.id.commentItemViewHolder) as CommentItemRendererV5.ViewHolder

        // TODO: 8/2/2019 Hacky fix
        // Related to resetIsCommentThreadEnded() in AbstractCommentSystemListingFragment
        if (isSeparateSubLevelLoadMore) {
            if (wrapper.getLevel() > 1) {
                view.image.visibility = View.GONE
            } else {
                view.image.visibility = View.VISIBLE
            }
        }

        commentMediaItemRendererDelegate.bindMediaContent(holder, pos, wrapper, view.context)

        return view
    }
}