package com.under9.android.comments.ui.renderer

import android.view.View
import com.under9.android.comments.CommentSystem
import com.under9.android.comments.controller.DataController
import com.under9.android.comments.data.repository.AppInfoRepositoryInterface
import com.under9.android.comments.model.constant.CommentConstant
import com.under9.android.comments.model.ui.CommentItemThemeAttr
import com.under9.android.comments.model.wrapper.CommentWrapperV2
import com.under9.android.lib.network.UrlMapperInterface
import com.xwray.groupie.ViewHolder
import kotlinx.android.synthetic.main.comment_system_list_item_inner_v5.view.*

open class MediaCommentItemItemBinder(
        private val dataController: DataController,
        private val appInfoRepository: AppInfoRepositoryInterface,
        private val urlMapperInterface: UrlMapperInterface,
        private val commentItemActionDelegate: CommentItemActionDelegate,
        private val commentItemClickListener: CommentItemClickListener
) : ExpandableCommentItemBinder<ViewHolder> {

    private val commentMediaItemRendererDelegate = CommentMediaItemRendererDelegate(
            appInfoRepository, dataController, urlMapperInterface,
            commentItemActionDelegate)

    override fun bind(commentWrapper: CommentWrapperV2, depth: Int,
                      themeAttr: CommentItemThemeAttr, viewHolder: ViewHolder, position: Int) {

        if (CommentConstant.TYPE_MEDIA == commentWrapper.getType() ||
                CommentConstant.TYPE_USER_MEDIA == commentWrapper.getType()) {
            viewHolder.itemView.image.visibility = View.VISIBLE
        } else {
            viewHolder.itemView.image.visibility = View.GONE
        }

        commentMediaItemRendererDelegate.bindMediaContent(viewHolder, position, commentWrapper, viewHolder.itemView.context)
    }
}