package com.under9.android.comments.ui.renderer

import android.os.Bundle
import com.under9.android.comments.model.wrapper.CommentWrapperInterface
import com.under9.android.lib.widget.uiv3.adapter.UIVAdapter

interface RendererItemActionListener {
    var selectedCommentId: Long
    fun onItemReply(position: Int, commentWrapper: CommentWrapperInterface?, prefill: String, suppData: Bundle?)  // db comment id, with extra params including the comment id which user actually tap on
    fun onItemMore(position: Int, commentWrapper: CommentWrapperInterface?, username: String)
    fun onItemLike(position: Int, commentId: String): Boolean
    fun onItemDislike(position: Int, commentId: String): Boolean
    fun onItemUnlike(position: Int, commentId: String): Boolean
    fun onLoadMorePrevItems(position: Int)
    fun onAuthorNameClick(authorName: String)
    fun onAuthorAvatarClick(authorName: String)
    fun onMentionedUserClick(username: String, accountId: String)
    fun shouldHightlightSelectedComment(): Boolean
    fun onLongClickMedia(position: Int, commentWrapper: CommentWrapperInterface?): Boolean
    fun onItemOpenOverlay(commentWrapper: CommentWrapperInterface?, uivAdapter: UIVAdapter)

    fun onItemReport(position: Int, commentWrapper: CommentWrapperInterface?)
    fun onItemReportAccepted(commentWrapper: CommentWrapperInterface?)
    fun onItemHide(position: Int, commentWrapper: CommentWrapperInterface?)
    fun onItemDelete(position: Int, commentWrapper: CommentWrapperInterface?)
    fun onItemCopy(commentWrapper: CommentWrapperInterface?)
    fun onItemShare(commentWrapper: CommentWrapperInterface?)
    fun onItemProBadge(commentWrapper: CommentWrapperInterface?)
    fun onRefresh(position: Int, commentWrapper: CommentWrapperInterface?)
    fun onItemUrl(commentWrapper: CommentWrapperInterface?, url: String)
}
