package com.under9.android.comments.ui.renderer

import android.text.TextPaint
import android.text.style.ClickableSpan
import android.view.View

import com.under9.android.comments.model.wrapper.CommentWrapperInterface

class UrlClickSpan internal constructor(
        private val commentWrapper: CommentWrapperInterface,
        private val mUrl: String,
        private val clickListener: OnClickListener
) : ClickableSpan() {

    override fun updateDrawState(ds: TextPaint) {

    }

    override fun onClick(widget: View) {
        clickListener.onClick(commentWrapper, mUrl)
    }

    interface OnClickListener {
        fun onClick(commentWrapper: CommentWrapperInterface, url: String)
    }
}
