package com.under9.android.lib.core.mvvm

import androidx.lifecycle.ViewModel
import io.reactivex.disposables.CompositeDisposable
import io.reactivex.disposables.Disposable
import timber.log.Timber

open class RxViewModel : ViewModel() {
    val disposables = CompositeDisposable()

    protected fun <T : Disposable> T.addSubscription(): T {
        disposables.add(this)
        return this
    }

    override fun onCleared() {
        super.onCleared()
        disposables.dispose()
        Timber.d("VM cleared")
    }
}