package com.under9.android.lib.widget.media.overlayv3

import androidx.constraintlayout.widget.ConstraintSet


fun ConstraintSet.connectALeftToRightOfB(a: Int, b: Int) {
    connect(
            a,
            ConstraintSet.START,
            b,
            ConstraintSet.END
    )

    connect(
            a,
            ConstraintSet.LEFT,
            b,
            ConstraintSet.RIGHT
    )
}


fun ConstraintSet.connectALeftToLeftOfB(a: Int, b: Int) {
    connect(
            a,
            ConstraintSet.START,
            b,
            ConstraintSet.START
    )

    connect(
            a,
            ConstraintSet.LEFT,
            b,
            ConstraintSet.LEFT
    )
}

fun ConstraintSet.connectARightToRightOfB(a: Int, b: Int) {
    connect(
            a,
            ConstraintSet.END,
            b,
            ConstraintSet.END
    )

    connect(
            a,
            ConstraintSet.RIGHT,
            b,
            ConstraintSet.RIGHT
    )
}


fun ConstraintSet.connectARightToLeftOfB(a: Int, b: Int) {
    connect(
            a,
            ConstraintSet.END,
            b,
            ConstraintSet.START
    )

    connect(
            a,
            ConstraintSet.RIGHT,
            b,
            ConstraintSet.LEFT
    )
}

fun ConstraintSet.connectABottomToBottomOfB(a: Int, b: Int) {
    connect(
            a,
            ConstraintSet.BOTTOM,
            b,
            ConstraintSet.BOTTOM
    )
}